####Function: Remove the column or row that containing over a certain percentage NA.####
RemoveNA = function(Data = Data, percent = 0.2)
{
  index_row=which(rowSums(is.nan(Data))>=percent*ncol(Data))
  if (length(index_row)>0)
  {
    Data=Data[-index_row,]
  }
  index_col=which(colSums(is.nan(Data))>=percent*nrow(Data))
  if (length(index_col)>0)
  {
    Data=Data[,-index_col]
  }
  return(Data)
}

####Function: Fill the other NA using the average of row(1,default) or column(2) (index parameter).####
FillNA_temp = function(Data=Data)
{
  Data[which(is.nan(Data))]=mean(Data,na.rm=T)
  return(Data)
}

FillNA=function(Data=Data,index=1)
{
  if (index==1)
  {
    Data=t(apply(Data,index,FillNA_temp))
  }else
  {
    Data=apply(Data,index,FillNA_temp)
  }
  return(Data)
}

####Function: Delect all zero rows####
Delect_zero = function(Data)
{
  if (length(which(rowSums(Data)==0))>0)
  {
    Data=Data[-which(rowSums(Data)==0),]
  }
  return(Data)
}

####Main####
####Read omics data####

####Remove the column or row that containing over 20% NA####
mRNA_temp=RemoveNA(mRNA_temp)
miRNA_temp=RemoveNA(miRNA_temp)
CNV_temp=RemoveNA(CNV_temp)
methy_temp=RemoveNA(methy_temp)
RPPA_temp=RemoveNA(RPPA_temp)
  
####Fill the other NA using the average of row####
mRNA_temp = FillNA(mRNA_temp)
miRNA_temp = FillNA(miRNA_temp)
CNV_temp = FillNA(CNV_temp)
methy_temp = FillNA(methy_temp)
RPPA_temp = FillNA(RPPA_temp)

####Delect all zero rows####
mRNA_temp = Delect_zero(mRNA_temp)
miRNA_temp = Delect_zero(miRNA_temp)
CNV_temp = Delect_zero(CNV_temp)
methy_temp = Delect_zero(methy_temp)
RPPA_temp = Delect_zero(RPPA_temp)

####log2 for mRNA and miRNA####
mRNA_temp = log2(mRNA_temp+1)
miRNA_temp = log2(miRNA_temp+1)
  
####Write the preprocessed data####

