####Function: Pre-select features in each omics data matrix (MAD or VAR)####
Feature_selection=function(Data, method="MAD", toprank=5000)
{
  if (nrow(Data)>=toprank) 
  {
    if (method=="VAR")
    {
      temp=apply(Data, 1, var) 
      Data=Data[which(rank(-temp)<=toprank),]
    }else 
    {
      temp=apply(Data, 1, mad)
      Data=Data[which(rank(-temp)<=toprank),]
    }
  }
  return(Data)
}

####mRNA data feature selection####
mRNA_feature_selection=function(Data)
{
  return(Feature_selection(Data=Data, method="VAR", toprank = 5000))
}

####miRNA data feature selection####
miRNA_feature_selection=function(Data)
{
  return(Data)
}

####CNV data feature selection####
CNV_feature_selection=function(Data)
{
  return(Data)
}

####Methylation data feature selection####
methy_feature_selection=function(Data)
{
  return(Feature_selection(Data=Data, method="VAR", toprank = 5000))
}

####RPPA data feature selection####
RPPA_feature_selection=function(Data)
{
  return(Data)
}

####Main####
####Read omics data####

####Select the features####
mRNA_temp = mRNA_feature_selection(mRNA_temp)
miRNA_temp = miRNA_feature_selection(miRNA_temp)
CNV_temp = CNV_feature_selection(CNV_temp)
methy_temp = methy_feature_selection(methy_temp)
RPPA_temp = RPPA_feature_selection(RPPA_temp)

####Write the preprocessed data####
