library(reshape2)
library(ggplot2)
library(RColorBrewer)

####mRNA####

mRNA_temp = ratio_mRNA
mRNA_temp = t(mRNA_temp)
#types = matrix(data=rownames(mRNA_temp), nrow = nrow(mRNA_temp),ncol = 1)
#colnames(types)="cancer type"
#mRNA_temp = cbind(mRNA_temp,types)
mRNA_temp = melt(mRNA_temp)
colnames(mRNA_temp)=c("cancer_type","cluster","value")

color = c(brewer.pal(9,"Reds")[-c(1,2,9)],brewer.pal(9,"Greens")[-c(1,2,3,7,8,9)],brewer.pal(9,"PuRd")[-c(1,2,7,8,9)],brewer.pal(9,"Blues")[-c(1,2,9)],brewer.pal(9,"Oranges")[-c(1,2,7,8,9)],brewer.pal(9,"Purples")[-c(1,2,3,8,9)],brewer.pal(8,"Set2")[-c(2,3,4,8)])
TCGA_label_mRNA = c("ALL","CLL","DLBC","LAML","LCML","MM",
                    "BLCA","KIRC","PRAD",
                    "BRCA","CESC","OV","UCEC",
                    "CHOL","COAD/READ","ESCA","LIHC","PAAD","STAD",
                    "GBM","LGG","MB","NB",
                    "LUAD","LUSC","MESO","SCLC",
                    "HNSC","SARC","SKCM","THCA")
names(color)=TCGA_label_mRNA

p = ggplot(mRNA_temp, aes(cluster, 100*value, fill = cancer_type)) +
  geom_col(position = "stack", width = 0.8) +
  #geom_bar(stat = "identity", width = 0.8) + 
  scale_fill_manual(values = color) + 
  labs(x = "", y = "Percentage (%)") +
  theme(panel.grid = element_blank(), panel.background = element_rect(color = 'black', fill = 'transparent'), strip.text = element_text(size = 12)) +
  theme(axis.text = element_text(size = 12), axis.title = element_text(size = 13), legend.title = element_blank(), legend.text = element_text(size = 11))
p


####miRNA####

miRNA_temp = ratio_miRNA
miRNA_temp = t(miRNA_temp)
miRNA_temp = melt(miRNA_temp)
colnames(miRNA_temp)=c("cancer_type","cluster","value")

color=c(brewer.pal(9,"Reds")[-c(1,2,9)],brewer.pal(9,"Greens")[-c(1,2,3,7,8,9)],brewer.pal(9,"PuRd")[-c(1,2,4,7,8,9)],brewer.pal(9,"Blues")[-c(1,2,9)],brewer.pal(9,"Oranges")[-c(1,2,7,8,9)],brewer.pal(9,"Purples")[-c(1,2,3,8,9)],brewer.pal(8,"Set2")[-c(2,3,4,8)])
TCGA_label_miRNA = c("ALL","CLL","DLBC","LAML","LCML","MM",
                     "BLCA","KIRC","PRAD",
                     "BRCA","OV","UCEC",
                     "CHOL","COAD/READ","ESCA","LIHC","PAAD","STAD",
                     "GBM","LGG","MB","NB",
                     "LUAD","LUSC","MESO","SCLC",
                     "HNSC","SARC","SKCM","THCA")
names(color)=TCGA_label_miRNA

p = ggplot(miRNA_temp, aes(cluster, 100*value, fill = cancer_type)) +
  geom_col(position = "stack", width = 0.8) +
  scale_fill_manual(values = color) + 
  labs(x = "", y = "Percentage (%)") +
  theme(panel.grid = element_blank(), panel.background = element_rect(color = 'black', fill = 'transparent'), strip.text = element_text(size = 12)) +
  theme(axis.text = element_text(size = 12), axis.title = element_text(size = 13), legend.title = element_blank(), legend.text = element_text(size = 11))
p


####CNV####

CNV_temp = ratio_CNV
CNV_temp = t(CNV_temp)
CNV_temp = melt(CNV_temp)
colnames(CNV_temp)=c("cancer_type","cluster","value")

color=c(brewer.pal(9,"Reds")[-c(1,2,9)],brewer.pal(9,"Greens")[-c(1,2,3,7,8,9)],brewer.pal(9,"PuRd")[-c(1,2,4,7,8,9)],brewer.pal(9,"Blues")[-c(1,2,3,9)],brewer.pal(9,"Oranges")[-c(1,2,7,8,9)],brewer.pal(9,"Purples")[-c(1,2,3,8,9)],brewer.pal(8,"Set2")[-c(2,3,4,8)])
TCGA_label_CNV = c("ALL","CLL","DLBC","LAML","LCML","MM",
                   "BLCA","KIRC","PRAD",
                   "BRCA","OV","UCEC",
                   "COAD/READ","ESCA","LIHC","PAAD","STAD",
                   "GBM","LGG","MB","NB",
                   "LUAD","LUSC","MESO","SCLC",
                   "HNSC","SARC","SKCM","THCA")
names(color)=TCGA_label_CNV

p = ggplot(CNV_temp, aes(cluster, 100*value, fill = cancer_type)) +
  geom_col(position = "stack", width = 0.8) +
  scale_fill_manual(values = color) + 
  labs(x = "", y = "Percentage (%)") +
  theme(panel.grid = element_blank(), panel.background = element_rect(color = 'black', fill = 'transparent'), strip.text = element_text(size = 12)) +
  theme(axis.text = element_text(size = 12), axis.title = element_text(size = 13), legend.title = element_blank(), legend.text = element_text(size = 11))
p


####METHY####

METHY_temp = ratio_methy
METHY_temp = t(METHY_temp)
METHY_temp = melt(METHY_temp)
colnames(METHY_temp)=c("cancer_type","cluster","value")

color=c(brewer.pal(9,"Reds")[-c(1,2,9)],brewer.pal(9,"Greens")[-c(1,2,3,7,8,9)],brewer.pal(9,"PuRd")[-c(1,2,4,7,8,9)],brewer.pal(9,"Blues")[-c(1,2,9)],brewer.pal(9,"Oranges")[-c(1,2,7,8,9)],brewer.pal(9,"Purples")[-c(1,2,3,8,9)],brewer.pal(8,"Set2")[-c(2,3,4,8)])
TCGA_label_METHY = c("ALL","CLL","DLBC","LAML","LCML","MM",
                     "BLCA","KIRC","PRAD",
                     "BRCA","OV","UCEC",
                     "CHOL","COAD/READ","ESCA","LIHC","PAAD","STAD",
                     "GBM","LGG","MB","NB",
                     "LUAD","LUSC","MESO","SCLC",
                     "HNSC","SARC","SKCM","THCA")
names(color)=TCGA_label_METHY

p = ggplot(METHY_temp, aes(cluster, 100*value, fill = cancer_type)) +
  geom_col(position = "stack", width = 0.8) +
  scale_fill_manual(values = color) + 
  labs(x = "", y = "Percentage (%)") +
  theme(panel.grid = element_blank(), panel.background = element_rect(color = 'black', fill = 'transparent'), strip.text = element_text(size = 12)) +
  theme(axis.text = element_text(size = 12), axis.title = element_text(size = 13), legend.title = element_blank(), legend.text = element_text(size = 11))
p


####RPPA####

RPPA_temp = ratio_RPPA
RPPA_temp = t(RPPA_temp)
RPPA_temp = melt(RPPA_temp)
colnames(RPPA_temp)=c("cancer_type","cluster","value")

color=color_type_RPPA=c(brewer.pal(9,"Reds")[-c(1,2,9)],brewer.pal(9,"Greens")[-c(1,2,3,7,8,9)],brewer.pal(9,"PuRd")[-c(1,2,4,7,8,9)],brewer.pal(9,"Blues")[-c(1,2,9)],brewer.pal(9,"Oranges")[-c(1,2,7,8,9)],brewer.pal(9,"Purples")[-c(1,2,3,8,9)],brewer.pal(8,"Set2")[-c(2,3,4,8)])
TCGA_label_RPPA = c("ALL","CLL","DLBC","LAML","LCML","MM",
                       "BLCA","KIRC","PRAD",
                       "BRCA","OV","UCEC",
                       "CHOL","COAD/READ","ESCA","LIHC","PAAD","STAD",
                       "GBM","LGG","MB","NB",
                       "LUAD","LUSC","MESO","SCLC",
                       "HNSC","SARC","SKCM","THCA")
names(color)=TCGA_label_RPPA

p = ggplot(RPPA_temp, aes(cluster, 100*value, fill = cancer_type)) +
  geom_col(position = "stack", width = 0.8) +
  scale_fill_manual(values = color) + 
  labs(x = "", y = "Percentage (%)") +
  theme(panel.grid = element_blank(), panel.background = element_rect(color = 'black', fill = 'transparent'), strip.text = element_text(size = 12)) +
  theme(axis.text = element_text(size = 12), axis.title = element_text(size = 13), legend.title = element_blank(), legend.text = element_text(size = 11))
p






