library(ggplot2)
library(scatterpie)
library(RColorBrewer)

color=c("#FCBBA1","#A1D99B","#D4B9DA","#FC9272","#9ECAE1","#FB6A4A",
        "#6BAED6","#FDD0A2","#66C2A5","#74C476","#EF3B2C","#CB181D",
        "#FDAE6B","#4292C6","#BCBDDC","#9E9AC8","#FD8D3C","#807DBA",
        "#A50F15","#F16913","#DF65B0","#2171B5","#41AB5D","#A6D854",
        "#6A51A3","#FFD92F","#08519C","#E5C494","#E7298A")
color=c(brewer.pal(9,"Reds")[-c(1,2,9)],brewer.pal(9,"Greens")[-c(1,2,3,7,8,9)],brewer.pal(9,"PuRd")[-c(1,2,4,7,8,9)],brewer.pal(9,"Blues")[-c(1,2,3,9)],brewer.pal(9,"Oranges")[-c(1,2,7,8,9)],brewer.pal(9,"Purples")[-c(1,2,3,8,9)],brewer.pal(8,"Set2")[-c(2,3,4,8)])
TCGA = c("ALL","CLL","DLBC","LAML","LCML","MM",
         "BLCA","KIRC","PRAD",
         "BRCA","OV","UCEC",
         "COAD/READ","ESCA","LIHC","PAAD","STAD",
         "GBM","LGG","MB","NB",
         "LUAD","LUSC","MESO","SCLC",
         "HNSC","SARC","SKCM","THCA")

#read data
cell_sum = apply(cluster_composition, 1, sum)
cluster_proportion_new = cbind(cluster_proportion,cell_sum)


cluster_proportion_new = as.data.frame(cluster_proportion_new)
radius = 0.05 
cluster_proportion_new$radius = radius
#Max_radius = max(radius)
#Bubble_Scale = 0.1
#cluster_proportion_new$radius = Bubble_Scale*radius/Max_radius


mydata = cluster_proportion_new[,c(1:29)]
cell_amount = cluster_proportion_new[,30]

x = (cell_amount-min(cell_amount))/(max(cell_amount)-min(cell_amount))+0.00001

xlabel = seq(10,100,10)
xbreak = (xlabel-min(cell_amount))/(max(cell_amount)-min(cell_amount))+0.00001
ylabel = seq(0,1.2,0.2)


dominate = c(0.84,0.47,0.37,0.73,0.51,0.41,0.89,0.81,0.62,0.75,0.70,0.97,0.23,0.91,0.98,0.54,0.76,0.25) 
mydata1 = data.frame(x=x,y=dominate,radius = cluster_proportion_new$radius)
mydata2 = cbind(mydata1,mydata)

Legnd_label = colnames(mydata)

ggplot()+
  geom_scatterpie(aes(x=x,y=y,r=radius),data = mydata2,cols = colnames(mydata),alpha=0.9,size=0.25)+
  scale_fill_manual(values = color,labels = Legnd_label)+
  scale_x_continuous(breaks = xbreak,labels = xlabel)+
  scale_y_continuous(breaks = ylabel,labels = ylabel)+
  theme_set(theme_bw()) + theme(panel.grid=element_line(colour=NA))+
  xlab("The number of cell lines")+
  ylab("Dominant cancer type proportion")+
  labs(title = "cell line number_proportion")
  coord_fixed()


