library(clusterProfiler)
library(org.Hs.eg.db)

####Main####
####Read omics data####

mRNA_down = mRNA_temp[which(mRNA_temp[,1]<0),]
mRNA_up = mRNA_temp[which(mRNA_temp[,1]>0),]
gene_list_down = rownames(mRNA_down)
gene_list_up = rownames(mRNA_up)
gene_list_down = as.numeric(gene_list_down)
gene_list_up = as.numeric(gene_list_up)

####Enrichment####
#down
CC_down = enrichGO(gene_list_down,
                 "org.Hs.eg.db",
                 keyType = "ENTREZID",
                 ont = "CC",
                 pvalueCutoff = 0.05,
                 pAdjustMethod = "BH",
                 readable = TRUE)
MF_down = enrichGO(gene_list_down,
                 "org.Hs.eg.db",
                 keyType = "ENTREZID",
                 ont = "MF",
                 pvalueCutoff = 0.05,
                 pAdjustMethod = "BH",
                 readable = TRUE)
BP_down = enrichGO(gene_list_down,
                 "org.Hs.eg.db",
                 keyType = "ENTREZID",
                 ont = "BP",
                 pvalueCutoff = 0.05,
                 pAdjustMethod = "BH",
                 readable = TRUE)
KEGG_down = enrichKEGG(gene_list_down,
                     organism = "human",
                     pvalueCutoff = 0.05,
                     pAdjustMethod = "BH")
#up
CC_up = enrichGO(gene_list_up,
              "org.Hs.eg.db",
              keyType = "ENTREZID",
              ont = "CC",
              pvalueCutoff = 0.05,
              pAdjustMethod = "BH",
              readable = TRUE)
MF_up = enrichGO(gene_list_up,
              "org.Hs.eg.db",
              keyType = "ENTREZID",
              ont = "MF",
              pvalueCutoff = 0.05,
              pAdjustMethod = "BH",
              readable = TRUE)
BP_up = enrichGO(gene_list_up,
              "org.Hs.eg.db",
              keyType = "ENTREZID",
              ont = "BP",
              pvalueCutoff = 0.05,
              pAdjustMethod = "BH",
              readable = TRUE)
KEGG_up = enrichKEGG(gene_list_up,
                organism = "human",
                pvalueCutoff = 0.05,
                pAdjustMethod = "BH")

####Draw barplot and dotplot####
dotplot(CC_down, title="GO_CC_down enrichment")
dotplot(MF_down, title="GO_MF_down enrichment")
dotplot(BP_down, title="GO_BP_down enrichment")
dotplot(KEGG_down, title="KEGG_down enrichment")
dotplot(CC_up, title="GO_CC_up enrichment")
dotplot(MF_up, title="GO_MF_up enrichment")
dotplot(BP_up, title="GO_BP_up enrichment")
dotplot(KEGG_up, title="KEGG_up enrichment")

####Write results####
