library("limma")
library("stringr")

####Function: Differential expressed genes between clusters ####
Cluster = function(Data,group)
{
  group[,1] = as.numeric(group[,1])

  ALL_names = NULL
  ALL_names = rownames(group)
  ALL_names = intersect(ALL_names, colnames(Data))
  Data = Data[,ALL_names]
  
  group_list = c(rep("cluster",length(group[which(group[,1]==18)])),rep("clusterother",length(group[which(group[,1]!=18)])))
  group_list = factor(group_list)
  design = model.matrix(~0+group_list)
  a=names(which(group[,1]==18))
  b=names(which(group[,1]!=18))
  c=c(a,b)
  rownames(design) = c
  colnames(design) = levels(group_list)
  
  v = voom(Data, design)
  fit = lmFit(v, design)
  cont.matrix = makeContrasts(c("cluster-clusterother"),levels = design)
  fit1 = contrasts.fit(fit, cont.matrix)
  fit1 = eBayes(fit1)
  allDEG = topTable(fit1,coef = "cluster-clusterother",n = Inf)
  allDEG = na.omit(allDEG)
  
  padj = 0.05
  foldChange= 1
  diff_signif = allDEG[(allDEG$adj.P.Val < padj & 
                          (allDEG$logFC>foldChange | allDEG$logFC<(-foldChange))),]
  diff_signif = diff_signif[order(diff_signif$logFC),]
  return(diff_signif)
}

####Main####
####Read omics data####

####Find differential expressed genes####
mRNA_diff = Cluster(mRNA_temp,multi_group)

####Write results####



